SystemOrganization addCategory: #'AmbientTalkST-Ost-Tests'!

OstTestCase subclass: #ATOstTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AmbientTalkST-Ost-Tests'!

!ATOstTests methodsFor: 'testing' stamp: 'StefanMarr 4/1/2012 10:28'!
execDomain
	^  OstDomain currentDomain! !

!ATOstTests methodsFor: 'testing' stamp: 'StefanMarr 4/1/2012 10:28'!
onBaselevel
	^ OstMirror executesOnBaseLevel! !

!ATOstTests methodsFor: 'tests' stamp: 'StefanMarr 1/23/2013 11:24'!
testActorAndDomain
	"Make sure that the actor is correctly associated with its domain"
	
	| actor p |
	actor := ATActor new.
	p := actor evaluateAsync: [ OstDomain currentDomain. 	].
	
	self assert: actor equals: p read.
	
	actor terminate! !

!ATOstTests methodsFor: 'tests' stamp: 'StefanMarr 1/23/2013 11:24'!
testActorAndDomainIndirect
	"Make sure that the actor is correctly associated with its domain"
	
	| actor p |
	actor := ATActor new.
	p := actor evaluateAsync: [ self execDomain ].
	
	self assert: actor equals: p read.
	
	actor terminate! !

!ATOstTests methodsFor: 'tests' stamp: 'StefanMarr 1/23/2013 11:24'!
testEvaluateAsyncOmnified
	"Make sure that the actor is correctly associated with its domain"
	
	| actor p |
	actor := ATActor new.
	
	 "This one is only for OmniST. The implementation is not stable
	  when run the first time, since we then still have the DNUs
	  on the stack that #executesOnBaseLevel does not handle."
	actor evaluateAsync: [ OstMirror executesOnBaseLevel. ].
	
	p := actor evaluateAsync: [ OstMirror executesOnBaseLevel. ].
	
	self assert: p read.
	
	actor terminate! !

!ATOstTests methodsFor: 'tests' stamp: 'StefanMarr 1/23/2013 11:25'!
testEvaluateAsyncOmnifiedIndirect
	"Make sure that the actor is correctly associated with its domain"
	
	| actor p |
	actor := ATActor new.
	p := actor evaluateAsync: [ self onBaselevel ].
	
	self assert: p read.
	
	actor terminate! !

!ATOstTests methodsFor: 'tests' stamp: 'StefanMarr 3/22/2012 14:49'!
testNewWithInitializerOmni
	"For the real AmbientTalk feeling"
	| result domain |
	result := ATActor newWithInitializer: [ATHelloWorld new].
	
	self assert: (result isKindOf: ATHelloWorld) description: 'Result should be the blocks return value'.
	
	domain := OstMirror domainOf: result.
	self assert: domain notNil description: 'The domain of the ATHelloWorld object should have been properly initialized...'.
	self assert: (domain isKindOf: ATActor) description: '... to the ATActor object.'. ! !
